import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Protagonista que es usado mediante las flechas de movimiento.
 */
public class Humano extends Animal
{
    private int gusanosEaten;
    
    
    public Humano()
    {
        setImage("derecha.png");  //imagen del principio
        gusanosEaten = 0;
                
    }
        public void act()
    { 
     EspadaFantasma();       
     controlDeTeclas();        
     getWorld().showText("Mata a los fantasmas:" +gusanosEaten,200,50);  //muestra en el mundo el texto escrito     
     espada();
    
    }
    /**
     * Este metodo da espadazos y come fantasmas al pulsar espacio y al estar encima de este, segun donde mire cambiar
     * a una foto o a otra obteniendo al rotacion del humano, pegara espadazos independientemente de estar encima del 
     * fantasma y realizara un sonido al dar el espadazo, al comerse un fantasma, este sumara +1 al contador.
     * Si llega a 8 fantasmas comidos, parara el juego con un sonido incluido ademas de un cartel.
     */
        public void EspadaFantasma()
    {
     if(Greenfoot.isKeyDown("space")) 
     {        
        if (getRotation() == 0) 
        {
            setImage("derechaES.png");  
            Greenfoot.playSound("espada2.mp3");
            if(canSee(Fantasma.class))  
            {
                eat(Fantasma.class);  
                gusanosEaten = gusanosEaten+1; 
            }            
        }
        if (getRotation() == 90)
        {
            setImage("abajoES.png");
            Greenfoot.playSound("espada2.mp3");
            if(canSee(Fantasma.class))
            {
                eat(Fantasma.class);
                gusanosEaten = gusanosEaten+1;
            }
        }
        if (getRotation() == 180)
        {
            setImage("izqES.png");   
            Greenfoot.playSound("espada2.mp3");
            if(canSee(Fantasma.class))
            {
                eat(Fantasma.class);
                gusanosEaten = gusanosEaten+1;
            }
        }
        if (getRotation() == 270)
        {
            setImage("arribaES.png");
            Greenfoot.playSound("espada2.mp3");
            if(canSee(Fantasma.class))
            {
                eat(Fantasma.class);
                gusanosEaten = gusanosEaten+1;
            }
        }
        if (gusanosEaten == 8)  //si se come 8 fantasmas...
        {
            Greenfoot.playSound("fanfare.wav"); 
            getWorld().showText("HUMANO GANA",310,250);
            Greenfoot.stop();  
        }
     }
    } 
            /**
     * Este metodo hace que puedas controlar al humano con las teclas, segun pulses una tecla cambiara su rotacion y su
     * a la que se necesite.
     */
       public void controlDeTeclas()
    {
        if(Greenfoot.isKeyDown("left"))  
        {
          setRotation(180);  
          move(6); 
          setImage("izquiedaa.png"); 
         
        }
        if(Greenfoot.isKeyDown("right"))
        {
          setRotation(0);
          move(6);
          setImage("derecha.png");
         
        }
        if(Greenfoot.isKeyDown("up"))
        {
          setRotation(270);
          move(6);
          setImage("arriba.png");
         
        }
        if(Greenfoot.isKeyDown("down"))
        {
            setRotation(90);
            move(6);
            setImage("abajo.png");
        }
    }
    /**
       * Este mtodo hace que el humano actue normal despues de un espadazo, al no pulsar espacio este volvera a su
       * imagen natural de donde este mirando en ese momento, que sabremos a donde mira por que obtendremos su rotacion.
     */
        public void espada()
    {
     if(!Greenfoot.isKeyDown("space"))  
     {
        if(getRotation() == 0)  
        {
            setImage("derecha.png");             
        }
        if(getRotation() == 90)
        {
            setImage("abajo.png");
        }
        if(getRotation() == 180)
        {
            setImage("izquiedaa.png");
        }
        if(getRotation() == 270)
        {
            setImage("arriba.png");
        }
     }
    }
}