import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * El monstruo come al humano para ganar. 
 */
public class Monstruo extends Animal
{
    
        /**
     * Se ejecuta todo el tiempo
     */
    public void act() 
    {
     comerhumano();          
     controlDeTeclas();
    }
    /**
     * Este metodo come al humano, que si este esta encima este cambia la imagen a una explosion y 
     * introduce un texto de victora para el monstruo y para el juego.
     */
        public void comerhumano()
    {
     if (canSee(Humano.class))
     {
        eat(Humano.class);   //come la clase humano cuando esta encima
        setImage("explosi.png");  //cambio la imagen a explosin cuando se lo come
        getWorld().showText("MONSTRUO GANA",310,250);
        getWorld().showText("",200,50);
        Greenfoot.stop();    //para el juego despues de comerselo       
     }
    }         
    /**
     * Este metodo hace que controles al monstruo, se movera con w,a,s,d y al igual que el humano 
     * al pulsar una tecla, cambia de direccion y de imagen. Ademas si este se encuentra al humano 
     * mientras se mueve, se lo comera.
     */
       public void controlDeTeclas()
     {
       if(Greenfoot.isKeyDown("a"))
        {
          setRotation(180);  
          move(2);  
          setImage("monsterizq.png"); 
            if (canSee(Humano.class))
          {
             eat(Humano.class);              
             setImage("explosi.png");
             getWorld().showText("MONSTRUO GANA",310,250);
             getWorld().showText("",200,50);
             Greenfoot.stop();
          }          
         }
       if(Greenfoot.isKeyDown("d"))
        {
          setRotation(0);
          move(2);
          setImage("monsterderecha.png");
            if (canSee(Humano.class))
          {
             eat(Humano.class);              
             setImage("explosi.png");
             getWorld().showText("MONSTRUO GANA",310,250);
             getWorld().showText("",200,50);
             Greenfoot.stop();
          }
        }
       if(Greenfoot.isKeyDown("w"))
        {
          setRotation(270);
          move(2);
          setImage("monsterarriba.png");
            if (canSee(Humano.class))
          {
             eat(Humano.class);              
             setImage("explosi.png");
             getWorld().showText("MONSTRUO GANA",310,250);
             getWorld().showText("",200,50);
             Greenfoot.stop();
          }
        }
       if(Greenfoot.isKeyDown("s"))
        {
          setRotation(90);
          move(2);
          setImage("monsterabajo.png");
            if (canSee(Humano.class))
          {
             eat(Humano.class);              
             setImage("explosi.png");
             getWorld().showText("MONSTRUO GANA",310,250);
             getWorld().showText("",200,50);
             Greenfoot.stop();
          } 
        }       
    } 
    }

